
{% extends "base.html" %}

{% load filters %}

{% block title %}Planning - Fabrication{% endblock  %}

{% block content %}


<a href="/fabrication?{{dates|previous_week}}" class="btn btn-secondary">Semaine précédente</a>
<a href="/fabrication?{{dates|next_week}}" class="btn btn-secondary">Semaine suivante</a>


        <div id="tableau">
            <div id="blank"></div>
            {% for machine in machines %}
                <div class="machine" style="grid-row: {{ forloop.counter|add:2 }} / span 1;">
                    {{ machine.nom }}
                    
                </div>
            {% endfor %}

            {% for machine in machines %}
                <div class="fabrication-placeholder" style="grid-row: {{ forloop.counter|add:2 }} / span 1;">
                    {% for ordre_fabrication in machine.ordres_fabrications.all %}
                    {% with fabrication=ordre_fabrication.fabrication %}
                    {% if fabrication %}
                        <div class="fabrication" style="left: {{ fabrication.date_debut|date_diff:base_date|duration_to_pixel }}px; width: {{ordre_fabrication.temps_fabrication|default:8|duration_to_pixel}}px;">
                            <div class="status">
                                    {% if ordre_fabrication.pesee %}
                                <div 
                                    class="status-pesee"
                                    data-bs-toggle="tooltip" 
                                    data-bs-placement="top"
                                    data-bs-title="Status pesée : {{ordre_fabrication.pesee.status|status_pesee}}">
                                        <div class="done" style="width:{{ordre_fabrication.pesee.status|status_pesee_to_percentage}}%"></div>
                                    <div class="not-done"></div>
                                </div>
                                    {% endif %}
                                <div
                                    class="status-fabrication"
                                    data-bs-toggle="tooltip" 
                                    data-bs-placement="top"
                                    data-bs-title="Status fabrication : {{fabrication.status|status_fabrication}}">
                                    <div class="done" style="width:{{fabrication.status|status_fabrication_to_percentage}}%"></div>
                                    <div class="not-done"></div>
                                </div>
                            </div>
                            <div class="of">OF : {{ ordre_fabrication.numero_of }}</div>
                            <div class="formule">Vrac : {{ ordre_fabrication.formule.code_vrac }}</div>
                            <div class="designation">Des : {{ ordre_fabrication.formule.designation }}</div>
                            <div class="infos">Infos : {{ fabrication.informations }}</div>
                            <div class="dropdown status-picker">
                                <button class="btn btn-outline-secondary btn-sm" type="button" data-bs-toggle="dropdown" aria-expanded="false">
                                    <i class="fa-solid fa-list-check fa-fw"></i>
                                </button>
                                <ul class="dropdown-menu">
                                  <li><a class="dropdown-item" href="/fabrication/update/status?idFabrication={{ fabrication.id }}&status=NON_DEMARRE">N</a></li>
                                  <li><a class="dropdown-item" href="/fabrication/update/status?idFabrication={{ fabrication.id }}&status=EC_MOINS">EC-</a></li>
                                  <li><a class="dropdown-item" href="/fabrication/update/status?idFabrication={{ fabrication.id }}&status=EC_PLUS">EC+</a></li>
                                  <li><a class="dropdown-item" href="/fabrication/update/status?idFabrication={{ fabrication.id }}&status=TERMINE">X</a></li>
                                </ul>
                            </div>
                            <div class="dropdown actions">
                                <button class="btn btn-outline-secondary  btn-sm" type="button" data-bs-toggle="dropdown" aria-expanded="false">
                                    <i class="fa-solid fa-ellipsis fa-fw"></i>
                                </button>
                                <ul class="dropdown-menu">
                                <li><a class="dropdown-item" href="/fabrication/{{ fabrication.id }}/update">update</a></li>
                                <li><a class="dropdown-item" href="/fabrication/{{ fabrication.id }}/delete">delete</a></li>
                                </ul>
                            </div>
                        </div>
                    {% endif %}
                    {% endwith %}
                    {% endfor %}
            </div>
        {% endfor %}


            {% for date in dates %}
                {% with date_index=forloop.counter0 %}
                <div class="date" style="grid-column: {{ date_index|product:3|add:3 }} / span 3;">
                    <strong>{{ date|date:"D d M y" }}</strong>
                </div>

                <div class="equipe" style="grid-column: {{ date_index|product:3|add:3 }} / span 1;">nuit</div>
                {% for machine in machines %}
                    <div class="custom-border" data-equipe="n" style="grid-column: {{ date_index|product:3|add:2 }} / span 1; grid-row: {{ forloop.counter|add:2 }} / span 1;">
                        <a href="fabrication/new?date_debut={{date|equipe_time:'nuit'|urlencode}}&machine_id={{machine.id}}" type="button" class="btn btn-outline-secondary"><i class="fa-solid fa-circle-plus"></i></a>
                    </div>
                {% endfor %}
                <div class="equipe" style="grid-column: {{ date_index|product:3|add:4 }} / span 1;">matin</div>
                {% for machine in machines %}
                    <div class="custom-border" data-equipe="am" style="grid-column: {{ date_index|product:3|add:3 }} / span 1; grid-row: {{ forloop.counter|add:2 }} / span 1;">
                        <a href="fabrication/new?date_debut={{date|equipe_time:'matin'|urlencode}}&machine_id={{machine.id}}" type="button" class="btn btn-outline-secondary"><i class="fa-solid fa-circle-plus"></i></a>
                    </div>
                {% endfor %}
                <div class="equipe" style="grid-column: {{ date_index|product:3|add:5 }} / span 1;">après-midi</div>
                {% for machine in machines %}
                    <div class="custom-border" data-equipe="pm" style="grid-column: {{ date_index|product:3|add:4 }} / span 1; grid-row: {{ forloop.counter|add:2 }} / span 1;">
                        <a href="fabrication/new?date_debut={{date|equipe_time:'apres-midi'|urlencode}}&machine_id={{machine.id}}" type="button" class="btn btn-outline-secondary"><i class="fa-solid fa-circle-plus"></i></a>
                    </div>
                {% endfor %}
                {% endwith %}
            {% endfor %}
        </div>

        <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.3.2/dist/js/bootstrap.bundle.min.js" integrity="sha384-C6RzsynM9kWDrMNeT87bh95OGNyZPhcTNXj1NW7RuBCsyN/o0jlpcV8Qyq46cDfL" crossorigin="anonymous"></script>
        <script>
            const tooltipTriggerList = document.querySelectorAll('[data-bs-toggle="tooltip"]')
            const tooltipList = [...tooltipTriggerList].map(tooltipTriggerEl => new bootstrap.Tooltip(tooltipTriggerEl, { container: 'body' }))
            document
                .querySelectorAll('.fabrication')
                .forEach(f => f.addEventListener('mouseover', e => { console.log("hover !"); e.stopPropagation() }));
        </script>
{% endblock  %}
    